obj

  key   :       "keyboard"
  rtc   :       "clkengine"
  tfmt  :       "tdfmt"
  vid   :       "vga_text_nf"
  sf    :       "strfmt"
  bsf   :       "bufstrfmt"

pub set | s, s0, c, ptr

  vid.str(string(7, 13,13))
  vid.str(string("   Show A=12/24 B=Sec C=Day",13))
  vid.str(string("   D=!Spell Month   E=!mmdd",13))
  vid.str(string("   F=!4 digit Year",13,13))
  vid.str(string("                   ESC=Exit"))

  s0 := $FF
  repeat
    repeat while (c := key.key) <> 0
      case c
        "a".."z":
          'touppercase
          c -= 32  
      case c
        $CB:
          return
        "A".."H":
          'toggle bits A-H = 0..7
          tfmt.setstyle(tfmt.getstyle ^ |<(c - "A"))
      s0 := $FF 'force screen redraw
    rtc.service
    s := tfmt.second(rtc.readtime)
    if s <> s0
      'redraw when second changes
      vid.out(1)
      'assign a big enough buffer and build T/D string in place
      'this reduces churning of the bufstr return buffer
      ptr := bsf.bufalloc(40)
      sf.cat(ptr, tfmt.timefmt(rtc.readtime))
      sf.chcat(ptr, " ")
      sf.cat(ptr, tfmt.datefmt(rtc.readdate))
      'and center the whole thing on screen
      vid.str(bsf.cstr(ptr, vid#cols))
      s0 := s
