obj

  key   :       "keyboard"
  rtc   :       "clkengine"
  tfmt  :       "tdfmt"
  vid   :       "vga_text_nf"
  bsf   :       "bufstrfmt"


PUB set | c, s, s0, edptr, edfld

  vid.str(string(7, 13, 13))
  vid.str(string("   Use ",2,3," to Select Field",13))
  vid.str(string("   Use ",4,5," to Set Value",13,13,13))
  vid.str(string("               ESC = Exit"))

  edptr := 1
  edfld := 2
  s0 := $FF 'force immediate time draw
  repeat
    rtc.service
    repeat while (c := key.key) <> 0
      case c
        "a".."z":
          c -= 32  
      case c
        $CB:
          return
        $C0:
          edptr := edptr - 1 #> 1
        $C1:
          edptr := edptr + 1 <# 7
        $C2:
          rtc.bump(edfld, 1)
        $C3:
          rtc.bump(edfld, -1)
        "A".."H":
          tfmt.setstyle(tfmt.getstyle ^ |<(c - "A"))
      if tfmt.getstyle & tfmt#st_date_ddmm
        edfld := lookup(edptr:2,1,0,3,4,5,6)
      else
        edfld := lookup(edptr:2,1,0,3,5,4,6) 
      s0 := $FF 'force screen redraw
    s := tfmt.second(rtc.readtime)
    if s <> s0
      vid.str(string(1,"  "))
      'Note there is no point centering this display, since
      'there are unprinted characters for highlighting the
      'edit field which would mess up the count.
      vid.out(1)
      vid.str(tfmt.setclkfmt(rtc.readtime, rtc.readdate, edfld))
      s0 := s
      
      