{{
  User Input Methods

  These routiens keep the clkengine serviced while waiting for user input.
}}

obj

  key   :       "keyboard"
  rtc   :       "clkengine"
  vid   :       "vga_text_nf"
  bsf   :       "bufstrfmt"
  
pub WaitKey : c

  'wait for a keypress while servicing the clkengine

  repeat while (c := key.key) == 0
    rtc.service

pub DoInput(buf, x, y, len) | c, cursor, default[20]
{
  Do an input statement
}

  home(x, y)
  vid.str(bsf.chstr(" ",len+1))
  home(x, y)
  default[0] := 0
  if strsize(buf) > 0
    'there is a default
    vid.str(buf)
    c := waitkey
    case c
      $CB, $0D:
        'escape or CR, accept default
        return
    bytemove(@default, buf, len+1) 'in case of later escape
    home(x, y)
    vid.str(bsf.chstr(" ",len))
  else
    vid.out("_")
    c := waitkey
  cursor := 0
  repeat
    case c
      $0D:
        return
      $CB:
        bytemove(buf, @default, len+1) 'restore default
        return
      " ".."~":
        if cursor < len
          home(x+cursor, y)
          vid.out(c)
          vid.out("_")
          byte[buf + cursor++] := c
          byte[buf + cursor] := 0
      $C8:
        'backspace
        if cursor > 0
          cursor--
          byte[buf +cursor] := 0
          home(x+cursor, y)
          vid.out("_")
          vid.out(" ")
    c := waitkey

pri home(x, y)
  vid.out($A)
  vid.out(x)
  vid.out($B)
  vid.out(y)
    